/*-------------------------------------------------------------------------+
| Dynamic memory package, virtual object store, messages                   |
| (SUN version)                                                            |
|                                                                          |
| Date of last updating: 18 November 1991                                  |
|                                                                          |
| Copyright (C) 1991 by Kazimierz Subieta.                                 |
| This software is subject to a licence agreement.                         |
| No restrictions when used for didactic purposes.                         |
+_________________________________________________________________________*/


/* Messages in dynamic memory and virtual object store */

#include	<stdio.h>
#include	<string.h>
#include	<messages.h>

typedef struct
  {
    unsigned short int	MSGNO;
    char *		MSGTEXT;
  } MessageItem;

/* Note that the table of messages is ended by 0, NULL */

static MessageItem ERR_MSG[ ] =
  {

/* Dynamic memory */

sDM_NO_MEMORY		, " <DM: no memory> ",

sDM_WRONG_DM		, " <Wrong DM %u> ",

sDM_WRONG_DM_FILE_READ	, " <Wrong DM file: read> ",

sDM_PROHIBIT_OPERATION	, " <DM: prohibited operation on fixed object> ",

sDM_TOO_MANY_DM_OBJECTS	, " <Too many DM objects> ",

sDM_WRONG_DM_FILE_OPEN	, " <Wrong DM file: open> ",

sDM_WRONG_DM_FILE_WRITE	, " <Wrong DM file: write> ",

sDM_VIOLATED_ASSERTION  , " <Violated assertion> ", 


/* Object store */

sSTANDARD_NAME_0x 	, "Standard name 0x%X",

sUNKNOWN_NAME_0x	, "Unknown name 0x%X",

sWRONG_FILE_FOR_POINT	, "<Wrong file for point %d.%ld>", 		 

sWRONG_FILE		, "<Wrong file %d>",

sINCONSISTENCY_GARBAGE	, "  ! Inconsistency! The point belongs to garbage !!!",

sINCONSISTENCY_OWNER	, "\n! Inconsistency! owner is %d.%ld; should be %d.%ld",

sOF_SIZE		, " (of size %ld) ",

sWRONG_SEARCH		, "\n!!! Wrong search for %ld", 

sPOINT_NOT_EXISTS	, "  Inconsistency! For point %s file doesn't exist!",

sATOM_OVERLAPS		, "  Inconsistency! Atom %s (%s) overlaps with another!",

sPOINT_WRONG_STRUCTURE	, "  Inconsistency! Point %s subordinated to %s (%s) has wrong structure or belongs to garbage!",

sINCONSISTENCY_POINT	, "  Inconsistency! For point %s (%s) ",

sOWNER_SHOULD_BE	, "  owner should be %s (%s) but it is %s",

sPOINTER_REPAIRED	, "  Inconsistency! Logical pointer %s (%s) points garbage %s; repaired.",

sPOINT_REPAIRED		, "  Inconsistency! Point %s (%s) pointing %s hasn't back pointer; repaired.",

sBACKWARD_REPAIRED	, "  Inconsistency of BACKWARD atom %s; repaired.",

sTOEND_REPAIRED		, "  Inconsistency of TOEND atom %s; repaired.",

sPOINT_ANYTHING		, "  Inconsistency of point %s ; cannot do anything!",

sFILE_SIZE_IMPROVED	, "  For file %d the size is %ld; improved to %ld",

sFILE_SIZE_UTILIZED	, "  File %d: size is %ld; utilized %ld (%ld%)",

sGARBAGE_CONSISTS	, "  Garbage consists of %ld pieces.",

sGARBAGE_INADEQUATE	, "  For file %d garbage is inadequate: its size is %ld; improved to %ld",

sTOTAL_ATOMS		, "  Total number of atoms: %ld",

sTOTAL_VALUES		, "  Total values size: %ld (%ld% of file(s), %ld% of utilized part.)",

/* End of messages in virtual object store */

0, NULL
 };


/*------------------------------------------------------- FindString -------*/
char *FindString( MESSAGENO )
    unsigned short int MESSAGENO;
  {
    int I;
    for(I = 0; ERR_MSG[I].MSGNO != 0; I++)
      {
        if( ERR_MSG[I].MSGNO == MESSAGENO )
            return( ERR_MSG[I].MSGTEXT );
      }
    return("");
  }

/*===========================================================================*/


